/*
								+---------------------------------+
								|                                 |
								| *** Pack progress indicator *** |
								|                                 |
								|  Copyright   -tHE SWINe- 2008  |
								|                                 |
								|           Progress.h            |
								|                                 |
								+---------------------------------+
*/

#ifndef __PACKER_PROGRESS_INDICATOR_INCLUDED
#define __PACKER_PROGRESS_INDICATOR_INCLUDED

/*
 *	class CMyProgressIndicator : public CPak2PackerUtil::CVerboseObject
 *		- progress indicator object for lame packer 2 (CPak2PackerUtil class)
 */
class CMyProgressIndicator : public CPak2PackerUtil::CVerboseObject {
	CTimer &m_r_timer;
	float m_f_start_time; // timer and start time

	uint64_t m_n_total_size;
	bool m_b_size_valid; // total size of files

	uint64_t m_n_total_in;
	uint64_t m_n_total_out;
	unsigned int m_n_block; // internal counters

public:
	/*
	 *	CMyProgressIndicator::CMyProgressIndicator(uint64_t n_total_size, bool b_size_valid,
	 *		CTimer &r_timer, float f_start_time)
	 *		- default constructor; sets total amount of data to be packed, wheter it is valid,
	 *		  timer and time when the packer was started
	 */
	CMyProgressIndicator(uint64_t n_total_size, bool b_size_valid,
		CTimer &r_timer, float f_start_time);

	/*
	 *	virtual void CMyProgressIndicator::On_TOCCompress(unsigned int n_in, unsigned int n_out)
	 *		- called when table of contents is compressed
	 *		- n_in is amount of data to be packed and n_out is resulting packed size
	 */
	virtual void On_TOCCompress(unsigned int n_in, unsigned int n_out);

	/*
	 *	virtual bool CMyProgressIndicator::On_BlockCompress(unsigned int n_in, unsigned int n_out)
	 *		- called when data block is compressed
	 *		- n_in is amount of data to be packed and n_out is resulting packed size
	 *		- returning false in this function makes packer fail immediately
	 */
	virtual bool On_BlockCompress(unsigned int n_in, unsigned int n_out);

	/*
	 *	void CMyProgressIndicator::PrintCompression()
	 *		- prints final average ratio and difference size
	 */
	void PrintCompression();

	/*
	 *	static void CMyProgressIndicator::PrintTime(float f_time)
	 *		- utility function
	 *		- prints time f_time [seconds] as hours:minutes:seconds.seconds/100
	 *		  to stdout (no newlines)
	 */
	static void PrintTime(float f_time);

	/*
	 *	void CMyProgressIndicator::PrintSize(uint64_t n_size)
	 *		- prints size n_size with proper size unit (B / kB / MB / GB / TB)
	 */
	static void PrintSize(uint64_t n_size);
};

#endif //__PACKER_PROGRESS_INDICATOR_INCLUDED
